;* (   )
;* ( Acad)
;* (   , Email,   .)

;* ABC_FUNCTION.LSP (FAS) [      ABC*]
;* 
;*         KAI. 
;
;* ** Acad 15,16
;* ** (c)  .., ., .(413-22)5-05-10   http://geol-dh.narod.ru/   ai_kosov@mail.ru
;* ** 2003 
;
;    

; ABC_UNLOCK_LAYER
; ABC_RTOD
; ABC_DTOR
; ABC_REGISTER_APP
; ABC_UNLOCK_LAYER
; ABC_CHECK_OBTYPE
; ABC_TSTYLE_LIST
; ABC_LAYER_LIST
; ABC_FILL_COLOR
; ABC_GETINDEX
; ABC_DIG2STR_COLOR
; ABC_HELP
; ABC_MES
; ABC_SAVE_SVAR
; ABC_RESTORE_SVAR
; ABC_LOGPROG
;
;
;-----------------------------------------------------------------------------------------------------------------
;     ,          ( )
;-----------------------------------------------------------------------------------------------------------------
(defun ABC_UNLOCK_LAYER (layname lockstr / )
  ;layname -    ,     
  ;lockstr -     ()
  (if (not (zerop (logand (cdr (assoc 70 (tblsearch "LAYER" layname))) 4)))
    (progn
      ; 
      (command "._-LAYER" "_Unlock" layname "")
      ;      
      (if (/= lockstr "")
        (setq lockstr (strcat lockstr "," layname))
        (setq lockstr (strcat lockstr layname))
      )
    )
  )
  ;        : "0,Layer1,LayerN,...."
  lockstr
);end of ******* ABC_UNLOCK_LAYER ********
;
;------------------------------------------
;     
;------------------------------------------
(defun ABC_RTOD (a)
  ;a -   
  (setq err$ "RTOD")
  (/ (* a 180.0) PI);    
) ;end of **** ABC_RTOD ******
;
;------------------------------------------
;     
;------------------------------------------
(defun ABC_DTOR (a)
  ; -   
  (setq err$ "DTOR")
  (* PI (/ a 180.0));    
) ;end of **** ABC_DTOR ******
;
;-----------------------------------------------------
;      
;-----------------------------------------------------
(defun ABC_REGISTER_APP (appname / reg) ;Extended data
  (setq reg T)
  (if (tblsearch "APPID" appname)
    (setq reg reg);    T
    (if (= (regapp appname) nil)
      (progn
        (princ (strcat "\n" "Can't register XDATA for" " " appname))
        (alert (strcat "Can't register XDATA for" " " appname ))
       	(setq reg nil)
      )	
    )
  )
  ;  T    nil   
  reg
);end of ********** ABC_REGISTER_APP *******
;
;
;-----------------------------------------------------------------------------------------------------------------
;     ,          ( )
;-----------------------------------------------------------------------------------------------------------------
(defun ABC_UNLOCK_LAYER (layname lockstr / )
  ;layname -    ,     
  ;lockstr -     ()
  (if (not (zerop (logand (cdr (assoc 70 (tblsearch "LAYER" layname))) 4)))
    (progn
      ; 
      (command "._-LAYER" "_Unlock" layname "")
      ;      
      (if (/= lockstr "")
        (setq lockstr (strcat lockstr "," layname))
        (setq lockstr (strcat lockstr layname))
      )
    )
  )
  ;        : "0,Layer1,LayerN,...."
  lockstr
);end of ******* ABC_UNLOCK_LAYER ********
;
;--------------------------------------------------------
;        
;--------------------------------------------------------
(defun ABC_CHECK_OBTYPE (en name_list / name str true)
  ;en - entname
  ;name_list -      : ("NAME1" "NAME2" ... "NAMEn"), : ("LINE" "POLYLINE")
  (setq name (cdr (assoc 0 (entget en))))
  (setq str "")
  (foreach n name_list
    (if (= name n)
      (setq true T)
    )
    (setq str (strcat str ", " n))
  );foreach
  (if (not true)
    (alert (strcat "bject selected" ":  " name ".\n\n"
                   "Allowed" ": " (substr str 3 (strlen str))
                   ))
  )
  ; T   ,  - nil
  true
);end of ******* ABC_CHECK_OBTYPE *********
;
;---------------------------------------------------------------------------------------------
;          (40 /= 0)     
;---------------------------------------------------------------------------------------------
(defun ABC_TSTYLE_LIST ( / sortlist templist name)
  (setq templist (tblnext "STYLE" T));    1     
  (while templist
    (setq name (strcase (cdr (assoc 2 templist))))
    (if (not (or (/= (cdr (assoc 40 templist)) 0.0) (= name "")))
      ;            
      (setq sortlist (cons name sortlist))
    )
    (setq templist (tblnext "STYLE"));     
  );while
  (if (>= (getvar "MAXSORT") (length sortlist))
    (setq sortlist (acad_strlsort sortlist))
    (alert (strcat "To sort styles name set sysvar value 'MAXSORT' more then" ": " (itoa (length sortlist))))
  )
  ;  -         NIL    
  sortlist ;: ("0" "STYLE-1" .... "STYLE-N")
);end of ******* ABC_TSTYLE_LIST **********
;
;--------------------------------------------------------------------
;         70  
;--------------------------------------------------------------------
(defun ABC_LAYER_LIST (flag / sortlist templist name)
  ;flag -   (+ 1 2 4 16 32),   -  (1  2 - , 4 - , 16  32 - xref)
  
  (setq templist (tblnext "LAYER" T));    1    
  (while templist
    (setq name (strcase (cdr (assoc 2 templist))))
    (if (and (zerop (logand (cdr (assoc 70 templist)) flag)) (/= name ""))
      ;     ,  
      ;( Xref,  ,    ..,    
      ;     )
      (setq sortlist (cons name sortlist))
    )
    (setq templist (tblnext "LAYER"));     
  )
  (if (>= (getvar "maxsort") (length sortlist))
    (setq sortlist (acad_strlsort sortlist));  
    (alert (strcat "To sort layers name set sysvar value 'MAXSORT' more then" ": " (itoa (length sortlist))))
  )
  ;  -       NIL    
  sortlist ;: ("0" "LAYER-1" .... "LAYER-N")
);end of ********* ABC_LAYER_LIST *********
;
;-------------------------------------------------------------------------------------------------------------
;     Acad            (DCL)
;-------------------------------------------------------------------------------------------------------------
(defun ABC_FILL_COLOR (flagwindow colnum tile / num width heigth)
  ;flagwindow -  = "YES"   Acad   
  ;colnum - [integer]    0  256 (.) 0-ByBlock, 256-ByLayer
  ;tile - [string]   ( )  DCL
  (if (or (< colnum 0) (> colnum 256));   
    (setq colnum 256); 
  )
  (if (and (= flagwindow "YES") (setq num (acad_colordlg colnum 1)));    Acad   ,        ( flagwindow)
    (setq colnum num)
  )
  (setq width  (dimx_tile tile);    
        height (dimy_tile tile))
  (start_image tile)
    (fill_image 0 0 width height colnum) ;  
  (end_image)
  (set_tile tile (strcat "  " (itoa colnum))) ;     
  ;  -   [integer]
  colnum
);end of ********* $_FILL_COLOR ***********
;
;----------------------------------------------------------------------------------------
;         (   DCL)
;----------------------------------------------------------------------------------------
(defun ABC_GETINDEX (item itemlist / m n)
  ;item -    (  )
  ;itemlist - 
  (setq n (length itemlist))
  (if (> (setq m (length (member item itemlist))) 0)
      (- n m)
      nil
  )
  ;       nil     
);end of ** ABC_GETINDEX **
;
;---------------------------------------------------
;    Acad ()   
;---------------------------------------------------
(defun ABC_DIG2STR_COLOR (digcol / chcol)
  ;digcol - (integer)    0-256 .
  ; -  (, , real,  ) -  - "ByLayer"
  (cond ((/= (type digcol) 'INT) (setq chcol "BYLAYER"))
        ((= digcol 0) (setq chcol "BYBLOCK"))
        ((= digcol 1) (setq chcol "RED"))
        ((= digcol 2) (setq chcol "YELLOW"))
        ((= digcol 3) (setq chcol "GREEN"))
        ((= digcol 4) (setq chcol "CYAN"))
        ((= digcol 5) (setq chcol "BLUE"))
        ((= digcol 6) (setq chcol "MAGENTA"))
        ((= digcol 7) (setq chcol "WHITE"))
        ((and (> digcol 7) (< digcol 256))
           (setq chcol (itoa digcol)))
        (T (setq chcol "BYLAYER"))
  )
  ;:    ( ) ,  "ByLayer"        Acad
); end of *** ABC_DIG2STR_COLOR ***
;
;--------------------------------------------------------------------
;     ,  Windows Help
;--------------------------------------------------------------------
(defun ABC_HELP (index / )
  ;index - (STRING)   WinHelp.        .
  ;         ,  ,     ( )
  (if (findfile "ABC_HELP.HLP"); WinHelp
    (help "ABC_HELP" index);    ABC_HELP.HLP   .
                             ;    ,         
    (alert (strcat "\n ABC_HELP.hlp."  "  Help file not found. "));  ,    
  )
  ; - 
) ;end *** ABC_HELP ******
;
;----------------------------------------------------------------------------
;            
;----------------------------------------------------------------------------
(defun ABC_MES (num / mes2)
  ;num  =  (int)
  ;,    ,     :
  ;
  ;abc_mesage_list =   : (    SET   )
  ;    '((0 "Massage_0" "_0")
  ;      (1 "Massage_1" "_1")
  ;      (2 "Massage_2" "_2"))  .. (      ,   0)
  ;abc_language  =   , : 1 - English 2 - 
  ;                 (   SET         Acad
  ;                  ,  ,      ABC)
  ;
  (if abc_mesage_list ;         SET?
    (if (setq mes2 (nth num abc_mesage_list)) ;   ,  (1 "Massage_1" "_1")
      (setq mes2 (nth abc_language mes2)) ;
    )  
  )
  ; ,         SET?  =nil Acad    ntn.
  ;    (1 "Massage_1" "_1")   num=1,
  ;        
  ;;        (..,     .)
  (if (and abc_mesage_list (setq mes2 (nth abc_language (nth num abc_mesage_list))))
    (setq mes2 mes2);    
    (progn
      (alert (strcat (itoa num) "\n" "Message not found.")); 
      (setq mes2 "_?_");    
    )
  )
  ;  -       "_1"
);end of **** ABC_MES *****
;
;-----------------------------------------------------------------------------------------------
;      (,  ,    )
;-----------------------------------------------------------------------------------------------
(defun ABC_SAVE_SVAR (svar_list / saved_svar_list errstr val)
  ;  svar_list = '("SYSVAR_NAME_1" "SYSVAR_NAME_2"....."SYSVAR_NAME_n"),    ()
  ;  : (setq saved_svar_list (ABC_SAVE_SVAR '("CMDECHO" "BLIPMODE" "FILLETRAD")))
  (setq errstr "")
  (foreach n svar_list
    (if (setq val (getvar n))
      (setq saved_svar_list (append saved_svar_list (list (list n val))))
      (setq errstr (strcat errstr "\n" (strcase n)));     ,       
    )
  );foreach
  ;       
  ;  ,       .
  ;    errstr     .
  (if (/= errstr "")
    (progn
      (alert (strcat errstr "\n\n*ERROR* Not found system variable to save." ));    Acad
      (princ (strcat "\n" errstr ". *ERROR* Not found system variable to save.";    Acad
             ));princ
    )
  )
  ;        :
  ; saved_svar_list = (("SYSVAR_NAME_1" value_1) ("SYSVAR_NAME_2" value_2).....("SYSVAR_NAME_n" value_n))
  ;  nil     
  saved_svar_list
);end of **** ABC_SAVE_SVAR ***
;
;----------------------------------------------------------------------------
;      
;   (         )
;----------------------------------------------------------------------------
(defun ABC_RESTORE_SVAR (saved_svar_list / i list-i)
  ; : saved_svar_list = '(("SYSVAR_NAME_1" value_1) ("SYSVAR_NAME_2" value_2).....("SYSVAR_NAME_n" value_n))
  ;   ABC_SAVE_SVAR, : (("CMDECHO" 1) ("BLIPMODE" 0) ("FILLETRAD" 7.0))
  
  ;      saved_svar_list,   ABC_SAVE_SVAR!!
  ;    ,      Acad!
  (foreach n saved_svar_list
    (setvar (car n) (cadr n))
  );foreach
  (prin1);  (   ).
);end of **** ABC_RESTORE_SVAR ***;


;----------------------------------------------------------------------------
;           ABC_LOGPROG.LOG
; (   ).
;           2-    
;----------------------------------------------------------------------------
;;
(defun ABC_LOGPROG (filename delim / fpath str df date0 date)
  ; fn [string] -   (), : "ABC_PRGNAME"
  ; abc_logprog_dir [string]  ,     ,     ABC_LOGPROG.LOG
  ; ABC_LOGPROG.LOG -      ABC_FUNCTION.LSP  ABC_FUNCTION.FAS.
  ; delim [string]      . "\t"=
  (if (not (and abc_logprog_dir (= (type abc_logprog_dir) 'STR)));     -   ,   
    (progn
      (if (or (setq fpath (findfile "ABC_FUNCTION.FAS")) (setq fpath (findfile "ABC_FUNCTION.LSP")));   
        (setq abc_logprog_dir (strcat (vl-filename-directory fpath) "\\ABC_LOGPROG.LOG"));     
        (princ "\nFile ABC_FUNCTION.FAS(LSP) not found.");    
      )
    )
  )
  ;        ,    CDATE   "YYYYMMDD"
  (setq date0 (rtos (getvar "CDATE") 2 0)) 
  (setq date (strcat (substr date0 7 2) ".";      "DD.MM.YYYY"
                     (substr date0 5 2) "."
                     (substr date0 1 4) 
             ))
  ;    : "ABC_PRGNAME\t20030211\t11.02.2003",
  ;         : ABC_PRGNAME     20030211        11.02.2003
  (setq str (strcat filename delim date0 delim date))
  ;        ,      LOG 
  (if abc_logprog_dir
    (progn
      (setq df (open abc_logprog_dir "a"));   
      ;    ,      , ,       
      (if df
        (write-line str df)
      )
      (close df) ;  
    )
  )
  str ;         : "ABC_PRGNAME\t20030211\t11.02.2003"
);end of ********** ABC_LOGPROG ************

;--------------------------------------------------------------------------------------
;     (     ABC) 
;--------------------------------------------------------------------------------------
(setq abc_function_flag )