;  ABC_PRGNAME           .
; 
;        - .
;
;
;** ( , ABC-     ,  , )
;** (  : ,    .)
;** (   )
;** (   ,    )
;** ( Acad)
;** (   , Email,   .)
;*
;* ABC_PRGNAME.LSP(FAS) [ ]
;*  Acad: ABC_PRGNAME 
;*
;*   (,   )     .
;*         .
;* ,    ,    .
;*  ,  .
;*
;*         KAI.       .
;*
;* ** Acad 15,16
;* ** (c)  .., ., .(413-22)5-05-10   http://geol-dh.narod.ru/   ai_kosov@mail.ru
;* ** 2003 
;*
;----------------------------------
;                   
;----------------------------------
;
; ABC_PRGNAME.LSP  FAS -  
; ABC_PRGNAME.DCL -   
; ABC_PRGNAME.SET -            
; ABC_PRGNAME.BMP -   ( )
; ABC_FUNCTION.LSP  FAS -       ABC*
;
;------------------------------------------------
;                           
;------------------------------------------------
;    TEXT.
;       .       .
;          ,    
;   TEXT,       ''  ,     250  ( -    )
;
;---------------------------------------------------------------
;                                   
;---------------------------------------------------------------
;
;      ,   LISP - ,   
; ABC_ -      ,     
; abc_ -   ,      ,     )
; glob_ -   ,        (     /   )
;
;     .
;
;---------------------------------------------
;   ,  
;---------------------------------------------
(defun ERASE_BOXES ( / selset i en xdlst hand_old en_old sumdel)
  ;   
  (setvar "OSMODE" glob_osm-old)
  ;  
  (princ (strcat "\n" (ABC_MES 24) ":"));24="Select set of texts to ERASE boxes around"
  ;   (  TEXT,   )
  (setq selset (ssget '((0 . "TEXT")))
           );setq selset
  ;  
  (setq glob_osm-old (getvar "OSMODE"))
  ;    
  (setvar "OSMODE" 0)
  ;    
  (if (and selset (> (sslength selset) 0))
    (progn
      (setq i 0 sumdel 0)
      ;       
      (while (setq en (ssname selset i))
        ;      (..     )
        (if (setq xdlst (cdr (cadr (assoc -3 (entget en (list glob_appname))))))
          (progn
            ;   
            (setq hand_old (cdr (assoc 1005 xdlst)))
            ;     (   )
            (if (setq en_old (handent hand_old))
              (if (entget en_old)
                (progn
                  ;   ( 
                  (setq glob_locklay_str (ABC_UNLOCK_LAYER (cdr (assoc 8 (entget en_old))) glob_locklay_str))
                  ;   
                  (entdel en_old)
                  ;    
                  (setq sumdel (1+ sumdel))
                )
              )
            )
          )
        ) 
        (setq i (1+ i))
      );while
      (if (/= sumdel 0)
        (princ (strcat "\n" (ABC_MES 25) ":  ";25="Number of boxes erased"
                       (itoa sumdel) ". " ))
      )
    )
  )
);end of ****** ERASE_BOXES *******
;
;-------------------------------------------------------------------------------------------------
;          ()   )
;-------------------------------------------------------------------------------------------------
(defun GET_TEXT_VALUE (txtvalue add_mode / newvalue flag message2user en_pt en txt)
  ;txtvalue -       
  ;add_mode -  -     T(), Nil()
  (setq flag T)
  (while flag
    ;   
    (setvar "OSMODE" glob_osm-old)
    ;   
    (setq message2user (strcat "\n" (ABC_MES 6) ": "));6="Select text"
    ;  
    (setq en_pt (entsel message2user))
    ;  
    (setq glob_osm-old (getvar "OSMODE"))
    ;    
    (setvar "OSMODE" 0)
    (if en_pt ;   
      (progn
        (setq en (car en_pt));   <Entity name>
        ;     
        (if (ABC_CHECK_OBTYPE en '("TEXT" "MTEXT"))
          (progn
            ;     
            (setq txt (cdr (assoc 1 (entget en))))
            (if (/= txt "")
              (if add_mode ;   ?
                (setq newvalue (strcat txtvalue txt));       
                (setq newvalue txt);       
              )
            )
            (setq flag nil);     
          )
        )
      )
      (progn
        (setq flag nil);     
        (setq newvalue txtvalue);      
      )
    )
  );while
  ;    (,   )
  newvalue
);end of ******** GET_TEXT_VALUE ********
;
;---------------------------------------------
;       
;---------------------------------------------
(defun CREATE_TEXT (pt / ht rot)
  ;pt -   
  ;    -         ( -     )
  (if (= abc_prgname_ht1 1)
    (setq ht abc_prgname_ht)
    (setq ht glob_curr_ht)
  )
  ;    -          ( - 0)
  (if (= abc_prgname_rot1 1)
    (setq rot (rtos abc_prgname_rot))
    (setq rot "0.0")
  )
  ;    ,  .        DCL_SETTINGS
  (if (/= abc_prgname_value "")
    (progn
      (if (or (= abc_prgname_just "_LEFT") (= abc_prgname_just1 0))
        (command "._TEXT" pt ht rot abc_prgname_value)
        (command "._TEXT" "_J" abc_prgname_just pt ht rot abc_prgname_value)
      )
      (setq en (entlast))
      ;    
      (DRAW_BOX en)
    )
  )
);end of ***** CREATE_TEXT *******
;
;-------------------------------------
;    
;-------------------------------------
(defun DRAW_VECTORS (pt_1st pt_end pt_list flag_close / i pt_list_new next_pt current_pt ang dis pt1 pt2)
  ;pt_1st -        
  ;pt_end -    
  ;pt_list -   (  2-),     
  ;flag_close -         (T  nil)
  (setq i 0)
  ;    ,     
  (while (setq next_pt (nth (1+ i) pt_list))
    (setq current_pt (nth i pt_list))
    ;        
    (setq ang (angle pt_1st pt_end))
    ;   
    (setq dis (distance pt_1st pt_end))
    ;    
    (setq pt1 (polar current_pt ang dis))
    (setq pt2 (polar next_pt ang dis))
    ;      
    (if (= i 0)
      (setq pt_list_new (append (list pt1) (list pt2) '()))
      (setq pt_list_new (append pt_list_new (list pt2)))
    )
    ;  
    (grdraw pt1 pt2 -1 1)
    (setq i (1+ i))
  );while
  (if flag_close
    (progn
      ;   ,       
      (grdraw (car pt_list_new) (last pt_list_new) -1 1)
    )
  )
  ;     
  pt_list_new
);end of ******* DRAW_VECTORS *******
;
;-----------------------------------------------
;      
;-----------------------------------------------
(defun APPEND_XDATA (reg appname en hand / exdata flag)
  ;reg -    (T  nil)
  ;appname -   
  ;en -   <Entity name> ()
  ;hand -   ( )
  (if (and reg hand appname en)
    (progn
      ;   ( )
      (setq glob_locklay_str (ABC_UNLOCK_LAYER (cdr (assoc 8 (entget en))) glob_locklay_str))
      ;       
      (setq exdata  (append (list (list -3 (list appname ; .
				             (cons 1005 hand)    ;handle
			              ))))
      )
      ;   
      (setq flag (entmod (append (entget en) exdata)))
    )
    (progn
      (princ (strcat "\n" "EXTENDED Data NOT ATTACHED to text.")); ,   
      (setq flag nil)
    )  
  )
  flag
);end of ******* APPEND_XDATA ********
;
;-------------------------------------------------------------------------------------
;     /   (  )
;-------------------------------------------------------------------------------------
(defun MOVE_LAST ( / last_pt box_points next_pt read_type read_val)
  ;    (   )
  (if (and glob_moveset (> (sslength glob_moveset) 0))
    (progn
      (setq glob_en (ssname glob_moveset 0))
      (redraw glob_en 3)
      ;  
      (setq last_pt glob_pt_last)
      (setq box_points glob_box_points)
      ;               
      (while last_pt
        ;    grread (  )      
        (setq next_pt (grread 1)
              read_type (car next_pt)
              read_val (cadr next_pt))
        (cond ((not (or (= read_type 5) (= read_type 3)));        
                 (progn
                   (setq last_pt_select nil)
                   (setq last_pt nil)
                 ))
              ((= read_type 3); 
                 (progn
                   ;             
                   (setq box_points (DRAW_VECTORS glob_pt_last read_val box_points T))
                   (setq last_pt_select read_val)
                   (setq last_pt nil)
                 ))
              (T ;    (read_type=5)
                 (progn
                   (redraw)
                   ;      
                   (DRAW_VECTORS glob_pt_last read_val box_points T)
                   (setq last_pt read_val)
                 ))
        );cond
      );while
      ;    
      (if last_pt_select
        (progn
          ;    
          (command "._MOVE" glob_moveset "" glob_pt_last last_pt_select)
          ;         
          (setq glob_pt_last last_pt_select)
          (setq glob_box_points box_points)
        )
        (progn
          (princ (strcat "\n" (ABC_MES 7)));7="Second point not spesified."
        )
      )
      (redraw glob_en 4)
    )
    (princ (strcat "\n" (ABC_MES 8)));8="Nothing to move."
  )
);end of ******** MOVE_LAST ********8
;
;
;     TEXT       
;
(defun DO_SELECTION_SET ( / selset i en )
  ;   
  (setvar "OSMODE" glob_osm-old)
  ;  
  (princ (strcat "\n" (ABC_MES 9) ":"));9="Select set of texts to draw boxes around"
  ;   (  TEXT,   )
  (setq selset (ssget '((0 . "TEXT")))
           );setq selset
  ;  
  (setq glob_osm-old (getvar "OSMODE"))
  ;    
  (setvar "OSMODE" 0)
;   TEXT  MTEXT
;;;  (setq selset (ssget '((-4 . "<OR")
;;;                        (0 . "TEXT")
;;;                        (0 . "MTEXT")
;;;                        (-4 . "OR>")
;;;                   )
;;;           ));setq selset
  ;    
  (if (and selset (> (sslength selset) 0))
    (progn
      (setq i 0)
      ;       
      (while (setq en (ssname selset i))
        (DRAW_BOX en)
        (setq i (1+ i))
      );while
      (princ (strcat "\n" (ABC_MES 10) ":  ";10="Number of boxes created"
                     (itoa (sslength selset)) ". " ))
    )
  )
);end of ******** DO_SELECTION_SET *****
;
;
;     
;
(defun DRAW_BOX (en / enlist list_text pt1 pt2 length_text distinspt offset0 text_ang height_text offset_box
                      inspt_text pt1box pt1box pt2box pt3box pt4box hand_new xdlst hand_old en_old xdlst_new
                      exdata max_radius1 max_radius2 radius)
  ;en - <Entity name>
  (setq enlist (entget en))
  ;          ( ,    0,0)
  (setq list_text (textbox enlist))
  (if list_text
    (progn
      (setq pt1 (car list_text)  ;         0,0,0
            pt2 (cadr list_text));   
      ;  
      (setq length_text (- (car pt2) (car pt1)))
      ;   0,0     (  )
      (setq distinspt (distance '(0 0) (list (car pt1) 0)))
      ;        
      (if (> (car pt1) 0)
        (setq offset0 "+")
        (setq offset0 "-")
      )
      ;   
      (if (not (setq text_ang (cdr (assoc 50 enlist))));      
        (setq text_ang 0.0)
      )
      ;  
      (setq height_text (cdr (assoc 40 enlist)))
      ;    
      (setq offset_box (* height_text abc_prgname_offset))
      ;    ()
      (setq inspt_text (cdr (assoc 10 enlist)))
      ;       
      (setq inspt_text (trans inspt_text en 1))
      ;    (  )
      (setq pt1box (polar inspt_text
                          (if (= offset0 "+")
                            text_ang
                            (+ text_ang PI)
                          )
                          distinspt))
      ;       
      (if (and (= abc_prgname_mode 2) (= abc_prgname_rad 0.0))
        (progn
          ;  
          (setq pt1box (polar pt1box (+ text_ang (* PI 1.25)) (/ offset_box (cos (* PI 0.25)))));    
          (setq pt2box (polar pt1box (+ text_ang (* PI 0.5)) (+ height_text offset_box offset_box)));  
          (setq pt3box (polar pt2box text_ang (+ length_text offset_box offset_box)));  
          (setq pt4box (polar pt3box (- text_ang (* PI 0.5)) (+ height_text offset_box offset_box)));  
        )
        (progn
          ;   
          (setq max_radius1 (/ (+ height_text offset_box offset_box) 2.0))
          (setq offset_boxleft 0.0)
          (if (= abc_prgname_mode 1)
            (setq radius max_radius1) ;  
            (progn
              ;   
              (setq radius abc_prgname_rad)
              (if (> radius max_radius1) 
                (setq radius max_radius1)
              )
              (if (>= radius offset_box)
                (setq offset_boxleft 0.0)
                (setq offset_boxleft (- offset_box radius))
              )
            )
          )
          (setq pt1box (polar pt1box (- text_ang (* PI 0.5)) offset_box))
          (setq pt1box (polar pt1box (+ text_ang PI) (+ radius offset_boxleft)))
          (setq pt2box (polar pt1box (+ text_ang (* PI 0.5)) (+ height_text offset_box offset_box)));  
          (setq pt3box (polar pt2box text_ang (+ length_text (+ radius offset_boxleft) (+ radius offset_boxleft))))
          (setq pt4box (polar pt3box (- text_ang (* PI 0.5)) (+ height_text offset_box offset_box)));  
        )
      )
      ;       
      (if (= abc_prgname_boxlayer1 1)
        (setvar "CLAYER" abc_prgname_boxlayer)
        (setvar "CLAYER" glob_curr_layer)
      )
      (setvar "CECOLOR" glob_curr_color);
      ;     
      (command "._PLINE" pt1box pt2box pt3box pt4box "_C")
      ;  
      (setq hand_new (cdr (assoc 5 (entget (entlast)))))
      ;        
      ;      (..     )
      (if (setq xdlst (cdr (cadr (assoc -3 (entget en (list glob_appname))))))
        (progn
          ;   
          (setq hand_old (cdr (assoc 1005 xdlst)))
          ;     (   )
          (if (setq en_old (handent hand_old))
            (if (entget en_old)
              (progn
                ;   ( 
                (setq glob_locklay_str (ABC_UNLOCK_LAYER (cdr (assoc 8 (entget en_old))) glob_locklay_str))
                ;   
                (entdel en_old)
                (princ (strcat "\n" (ABC_MES 11)));11="Old textbox erased."
              )
            )
          )
          ;       
          (setq xdlst_new (subst (cons 1005 hand_new) (assoc 1005 xdlst) xdlst))
          ;      (  )
          (setq exdata (append (list glob_appname) xdlst_new))
          (setq exdata (append (list -3 exdata)))
          ;   ( 
          (setq glob_locklay_str (ABC_UNLOCK_LAYER (cdr (assoc 8 (entget en))) glob_locklay_str))
          ;       Acad
          (if (entmod (append (entget en) (list exdata)))
            (princ (strcat " " (ABC_MES 12)));12="Text xdata updated."
            (princ (strcat "\n" "EXTENDED Data NOT ATTACHED to text.")); ,   
          )
        )
        ;      (     )
        (APPEND_XDATA glob_reg_appname glob_appname en hand_new)
      ) 
      ;                MoveLast
      ;   ( )
      (setq glob_pt_last (polar pt1box (angle pt1box pt3box) (/ (distance pt1box pt3box) 2.0)))
      ;   
      (setq glob_box_points (list pt1box pt2box pt3box pt4box))
      ;      
      (setq glob_moveset (ssadd en))
      (setq glob_moveset (ssadd (entlast) glob_moveset))
      ;    
      ;    
      (if (= abc_prgname_mode 1);   
        (progn
          ;   
          (command "._FILLET" "_R" radius)
          (command "._FILLET" "_P" (entlast))
        )
        ;   0 -   ,  -    
        (if (/= abc_prgname_rad 0.0)
          (progn
            ;   
            (command "._FILLET" "_R" radius)
            (command "._FILLET" "_P" (entlast))
          )
        )
      )
    )
    (alert (strcat "\n" "ACAD can't calculate length of string.")); ,   
  )
);end of ****** DRAW_BOX *********
;
;
;    DCL    (   ,   )
;
(defun MODE_TILE_DCL ()
  (if (/= glob_mode "CREATE TEXT")
    ;              (   )
    (progn ;
      (mode_tile "abc_prgname_layer1" 1) ;
      (mode_tile "abc_prgname_style1" 1) 
      (mode_tile "abc_prgname_ht1" 1) 
      (mode_tile "abc_prgname_rot1" 1) 
      (mode_tile "abc_prgname_just1" 1)
      (mode_tile "abc_prgname_color1" 1)
      (mode_tile "abc_prgname_value" 1)
      (mode_tile "abc_prgname_layer" 1)
      (mode_tile "abc_prgname_style" 1)
      (mode_tile "abc_prgname_ht" 1)
      (mode_tile "abc_prgname_rot" 1) 
      (mode_tile "abc_prgname_just" 1)
      (mode_tile "abc_prgname_color" 1)
      (mode_tile "abc_prgname_newvalue" 1)    ; 
      (mode_tile "abc_prgname_newvalue_add" 1)
      (mode_tile "abc_prgname_newpoint" 1)
    )
    (progn ;           
      (if (= abc_prgname_layer1 1);  
        (mode_tile "abc_prgname_layer" 0) ;
        (mode_tile "abc_prgname_layer" 1) ;
      )
      (if (= abc_prgname_style1 1);  
        (mode_tile "abc_prgname_style" 0)
        (mode_tile "abc_prgname_style" 1)
      )
      (if (= abc_prgname_ht1 1);  
        (mode_tile "abc_prgname_ht" 0)
        (mode_tile "abc_prgname_ht" 1)
      )
      (if (= abc_prgname_rot1 1);  
        (mode_tile "abc_prgname_rot" 0)
        (mode_tile "abc_prgname_rot" 1)
      )
      (if (= abc_prgname_just1 1);  
        (mode_tile "abc_prgname_just" 0)
        (mode_tile "abc_prgname_just" 1)
      )
      (if (= abc_prgname_color1 1);  
        (progn
          (mode_tile "abc_prgname_color" 0)
          (mode_tile "abc_prgname_colortxt" 0)
        )
        (progn
          (mode_tile "abc_prgname_color" 1)
          (mode_tile "abc_prgname_colortxt" 1)
        )
      )
    )
  )
  (if (= abc_prgname_mode 2);   (      )
    (mode_tile "abc_prgname_rad" 0) ;
    (mode_tile "abc_prgname_rad" 1) ;
  )
  (if (= abc_prgname_boxlayer1 1);   
    (mode_tile "abc_prgname_boxlayer" 0)
    (mode_tile "abc_prgname_boxlayer" 1)
  )
); end of ******** MODE_TILE_DCL ********
;
;
;      DCL  (     )
;  (        tyle "error")
;
(defun IF_DCL_ERROR ( / )
  (setq errstr "ERROR!")
  ;      
  (if (<= abc_prgname_ht 0)
    (progn
      (setq errstr (strcat  "\n" (ABC_MES 13) " ";13="Height of text must exceed null."
                            (ABC_MES) " 2.5"));14="Set to"
      (setq abc_prgname_ht 2.5)
      (set_tile "abc_prgname_ht" (rtos abc_prgname_ht 2 2));    
    )
  )
  ;      
  (if (< abc_prgname_rad 0)
    (progn
      (setq errstr (strcat  "\n" (ABC_MES 15) " ";15="Radius must be positive."
                            (ABC_MES) " 2.5"));14="Set to"
      (setq abc_prgname_rad 0.0)
      (set_tile "abc_prgname_rad" (rtos abc_prgname_rad 2 2));    
    )
  )
  ;        
  (if (< abc_prgname_offset 0)
    (progn
      (setq errstr (strcat  "\n" (ABC_MES 16) " ";16="Box offset must be positive."
                            (ABC_MES) " 2.5"));14="Set to"
      (setq abc_prgname_offset 0.0)
      (set_tile "abc_prgname_rad" (rtos abc_prgname_offset 2 2));    
    )
  )
  ;     (   )
  (if (/= errstr "ERROR!")
    (alert errstr)
  )
);end of ********* IF_DCL_ERROR *******
;
;
;          DCL 
;
(defun SET_TILECOLOR_TEXT ()
  (set_tile "abc_prgname_colortxt" (strcat "[ " (ABC_DIG2STR_COLOR abc_prgname_color) " ]"));  Acad  
);end of ** SET_TILETEXT **
;
;
;         
;
(defun DCL_SETTINGS ( /  number idx )
  ;      
  (if (= abc_language 1)
    (if (not (new_dialog "settings_ABC_PRGNAME" dcl-id "" c-dcl)) (EXIT))
    (if (not (new_dialog "settings_ABC_PRGNAME_RUS" dcl-id "" c-dcl)) (EXIT))
  )
  ;    DCL       
  (MODE_TILE_DCL)
  ;       
  (cond ((= abc_prgname_mode 1)
             (set_tile "abc_prgname_mode1" "1"); 
           )
        ((= abc_prgname_mode 2)
             (set_tile "abc_prgname_mode2" "1");   ,  R=0 - 
           )
  );cond
  ;   
  (set_tile "abc_prgname_rad" (rtos abc_prgname_rad 2 2))
  ;   
  (set_tile "abc_prgname_offset" (rtos abc_prgname_offset 2 2))
  ;     ?
  (set_tile "abc_prgname_boxlayer1" (itoa abc_prgname_boxlayer1))
  ;    
  (start_list "abc_prgname_boxlayer")
   (mapcar 'add_list glob_laylist)
  (end_list)
  ;         (,    ),
  ;        
  (if (not (member abc_prgname_boxlayer glob_laylist))
    (setq abc_prgname_boxlayer (car glob_laylist))
  )
  ;     
  (setq idx (ABC_GETINDEX abc_prgname_boxlayer glob_laylist))
  ;   
  (set_tile "abc_prgname_boxlayer" (itoa idx))
  ;       
  (set_tile "abc_prgname_value"  abc_prgname_value)         ;  
  (set_tile "abc_prgname_layer1" (itoa abc_prgname_layer1)) ;  
  (set_tile "abc_prgname_style1" (itoa abc_prgname_style1))
  (set_tile "abc_prgname_ht1"    (itoa abc_prgname_ht1))
  (set_tile "abc_prgname_rot1"   (itoa abc_prgname_rot1))
  (set_tile "abc_prgname_just1"  (itoa abc_prgname_just1))
  (set_tile "abc_prgname_color1" (itoa abc_prgname_color1))
  ;      
  (start_list "abc_prgname_layer")
   (mapcar 'add_list glob_laylist)
  (end_list)
  ;         (,    ),
  ;        
  (if (not (member abc_prgname_layer glob_laylist))
    (setq abc_prgname_layer (car glob_laylist))
  )
  (setq idx (ABC_GETINDEX abc_prgname_layer glob_laylist))
  (set_tile "abc_prgname_layer" (itoa idx))
  
  ;       
  (start_list "abc_prgname_style")
   (mapcar 'add_list glob_stylelist)
  (end_list)
  ;         (,    ),
  ;        
  (if (not (member abc_prgname_style glob_stylelist))
    (setq abc_prgname_style (car glob_stylelist))
  )
  ;      
  (setq idx (ABC_GETINDEX abc_prgname_style glob_stylelist))
  (set_tile "abc_prgname_style" (itoa idx))
  ;    
  (start_list "abc_prgname_just")
    (mapcar 'add_list prgname_just);   SET 
  (end_list)
  (set_tile "abc_prgname_just" (itoa (ABC_GETINDEX abc_prgname_just prgname_just)))
  ;  
  (set_tile "abc_prgname_ht" (rtos abc_prgname_ht 2 2))
  ;   
  (set_tile "abc_prgname_rot" (rtos abc_prgname_rot 2 2))
  ;       ( )
  (SET_TILECOLOR_TEXT)
  ;    ()
  (setq abc_prgname_color (ABC_FILL_COLOR "NO" abc_prgname_color "abc_prgname_color"));1- , 2-, 3- tile  DCL
  ;    
  (set_tile "error" (ABC_MES 5));5="Cancel - break program."
;;;
  ;      (tiles)    (DCL)
  ;  
  (action_tile "abc_prgname_mode1"  "(setq abc_prgname_mode 1)(MODE_TILE_DCL)")
  (action_tile "abc_prgname_mode2"  "(setq abc_prgname_mode 2)(MODE_TILE_DCL)")
  (action_tile "abc_prgname_rad"    "(setq abc_prgname_rad (atof $value))(IF_DCL_ERROR)")
  (action_tile "abc_prgname_offset" "(setq abc_prgname_offset (atof $value))(IF_DCL_ERROR)")
  (action_tile "abc_prgname_boxlayer1" "(setq abc_prgname_boxlayer1 (atoi $value))(MODE_TILE_DCL)")
  (action_tile "abc_prgname_boxlayer"  "(setq abc_prgname_boxlayer (nth (atoi $value) glob_laylist))")
  ;   ( )
  ;  
  (action_tile "abc_prgname_layer1" "(setq abc_prgname_layer1 (atoi $value))(MODE_TILE_DCL)")
  (action_tile "abc_prgname_style1" "(setq abc_prgname_style1 (atoi $value))(MODE_TILE_DCL)")
  (action_tile "abc_prgname_ht1"    "(setq abc_prgname_ht1 (atoi $value))(MODE_TILE_DCL)")
  (action_tile "abc_prgname_rot1"   "(setq abc_prgname_rot1 (atoi $value))(MODE_TILE_DCL)")
  (action_tile "abc_prgname_just1"  "(setq abc_prgname_just1 (atoi $value))(MODE_TILE_DCL)")
  (action_tile "abc_prgname_color1" "(setq abc_prgname_color1 (atoi $value))(MODE_TILE_DCL)")
  ; 
  (action_tile "abc_prgname_value" "(setq abc_prgname_value $value)")
  (action_tile "abc_prgname_layer" "(setq abc_prgname_layer (nth (atoi $value) glob_laylist))")
  (action_tile "abc_prgname_style" "(setq abc_prgname_style (nth (atoi $value) glob_stylelist))")
  (action_tile "abc_prgname_ht"    "(setq abc_prgname_ht (atof $value))(IF_DCL_ERROR)")
  (action_tile "abc_prgname_rot"   "(setq abc_prgname_rot (atof $value))")
  (action_tile "abc_prgname_just"  "(setq abc_prgname_just (nth (atoi $value) prgname_just))")
  (action_tile "abc_prgname_color" "(setq abc_prgname_color (ABC_FILL_COLOR \"YES\" abc_prgname_color \"abc_prgname_color\"))(SET_TILECOLOR_TEXT)")
  ;   
  (action_tile "accept"  "(done_dialog 1)");    OK
  (action_tile "cancel"  "(done_dialog 0)");    Cancel
  (action_tile "help" "(ABC_HELP \"ABC_PRGNAME\")");  Help
  (action_tile "abc_prgname_newpoint"     "(done_dialog 2)");    <   >
  (action_tile "abc_prgname_newvalue"     "(done_dialog 3)");      
  (action_tile "abc_prgname_newvalue_add" "(done_dialog 4)");     
  (setq e (start_dialog)); e =   cancel=0,  OK=1
  (if (= e 0)
    (setq e nil)
  )
  (if (= e 1)
    ;  OK -        (   ,  )
    (if (= glob_mode "CREATE TEXT")
      (progn
        (if (= abc_prgname_style1 1)
          (setvar "TEXTSTYLE" abc_prgname_style)
          (setvar "TEXTSTYLE" glob_curr_style)
        )
        (if (= abc_prgname_color1 1)
          (setvar "CECOLOR" (ABC_DIG2STR_COLOR abc_prgname_color));     
          (setvar "CECOLOR" glob_curr_color);
        )
        (setq glob_locklay_str (ABC_UNLOCK_LAYER abc_prgname_layer glob_locklay_str))
        (if (= abc_prgname_layer1 1)
          (setvar "CLAYER" abc_prgname_layer)
          (setvar "CLAYER" glob_curr_layer)
        )
      )
      (setq glob_locklay_str (ABC_UNLOCK_LAYER abc_prgname_boxlayer glob_locklay_str))
    )
  )
  e
);end of ** DCL_SETTINGS ***
;
;    ( Esc,  )
;
(defun M_ERROR (ert);ert = ,  Acad        
  ;    Esc
  (if (not (member ert '("Function cancelled" "console break" "quit / exit abort")))
    (princ (strcat "\nERROR in program ABC_PRGNAME: " ert));    ,   ESC
  )
  ;    /  
  (RESTORE_ON_EXIT)
  (prin1)
); end of ** M_ERROR **
;
;       ,    
;
(defun RESTORE_ON_EXIT ()
  ;      
  (setq *error* old-error)
  ;   ( )
  (redraw)
  ;   ,     (glob_en =     <Entity name: 4009d480>)
  (if glob_en (redraw glob_en 4))
  ;   ,   
  (if dcl-id (unload_dialog dcl-id))
  ;   ,    ,   
  (if (/= glob_locklay_str "") (command "._-LAYER" "_LOCK" glob_locklay_str ""))
;;;  ;  ,     (df= ,    )
;;;  (if df (close df))
  ;    
  (ABC_RESTORE_SVAR saved_svar_list)
  (if glob_osm-old (setvar "OSMODE" glob_osm-old)); 
  ;        (   .  _UNDO _BEGIN)
  (command "._UNDO" "_END") 
  (if cmd-old (setvar "CMDECHO" cmd-old));    
  ;     
  (setq CREATE_TEXT nil DRAW_VECTORS nil APPEND_XDATA nil MOVE_LAST nil
        DO_SELECTION_SET nil DRAW_BOX nil MODE_TILE_DCL nil IF_DCL_ERROR nil
        SET_TILECOLOR_TEXT nil DCL_SETTINGS nil
        M_ERROR nil RESTORE_ON_EXIT nil)
  ;  
  (prin1)
) ;end of ********** RESTORE_ON_EXIT **********

; *********************************************************
;
;    () ** ABC_PRGNAME **
;
; *********************************************************

(defun ABC_PRGNAME ( / cmd-old saved_svar_list old-error dcl-id c-dcl loop massage2user c e en add
                       ;  
                       glob_osm-old glob_mode glob_curr_ht glob_curr_layer glob_curr_color glob_curr_style
                       glob_moveset glob_pt_last glob_box_points glob_appname glob_reg_appname glob_laylist
                       glob_stylelist glob_locklay_str glob_en)
  ;  
  (setq cmd-old (getvar "CMDECHO"))
  ;     Acad   
  (setvar "CMDECHO" 0)
  ;      ( )
  (command "._UNDO" "_BEGIN");  (command "_UNDO" "_Mark")
  
  ;  ,   .   ,        ( ,   ).
  ; -  !!!
  (if (not abc_function_flag) ;   ,        ( or nil)
    (progn
      (if (or (findfile "ABC_FUNCTION.fas") (findfile "ABC_FUNCTION.lsp"))
        (progn
          (princ "\nLoading functions from ABC_FUNCTION...")
          (load "ABC_FUNCTION"); ,     (,  ,   )
          (princ "OK\n")
        )
        (progn
          ;     ,    .
          (alert "ABC_FUNCTION.  Function file not found.
                 \n\nCancel program.")
          (EXIT)
        )
      )
    )
  )
  
  ;    (  ,  )
  ;     ,  , :
  ;  ABC_PRGNAME_SETUP c    ,    
  ;      2- 
  (if (findfile "ABC_PRGNAME.SET");   SET -      LSP!!!
    (progn
      (princ (strcat "\nLoading parameters from ABC_PRGNAME.SET..."))
      (load "ABC_PRGNAME.SET");  ,   
      (princ (strcat "OK\n"))
    )
    (progn
      ;     ,    .
      (alert "ABC_PRGNAME.SET.  Parameters file not found.
             \n\nCancel program.")
      (EXIT)
    )
  )
  ;       ,   

  ;  F1       
  ;(   -   WinHelp-, - )
  (if (findfile "ABC_HELP.HLP")
    ;:     Acad, WinHelp ,   
    (setfunhelp (strcat "C:" "ABC_PRGNAME") "ABC_HELP" "ABC_PRGNAME")
    (princ (strcat "\nABC_HELP.hlp."  "  " "Help file not found." " "));,    ,   alert
  )
  
  ;  ,    ("CMDECHO"  "OSMODE"   )
  (setq saved_svar_list (ABC_SAVE_SVAR '("BLIPMODE"
                                        ;"PLINEWID"
                                        ;"CELTYPE"
                                        "CLAYER"
                                        "CECOLOR"
                                        "TEXTSTYLE"
                                        "TEXTSIZE"
                                        "DIMZIN"; ..
                                     )))
  (setq glob_curr_layer (getvar "CLAYER"))
  (setq glob_curr_style (getvar "TEXTSTYLE"))
  (setq glob_curr_color (getvar "CECOLOR"))
  (setq glob_curr_ht    (getvar "TEXTSIZE"))
  ;   "OSMODE"
  ;  ,         OSNAP,
  ;    ,   ,        .
  (setq glob_osm-old (getvar "OSMODE"))
    
  ;        
  (setq old-error  *error*  ; 
        *error* M_ERROR     ; 
  )

  ;     LOG     (  ,    )
  (ABC_LOGPROG "ABC_PRGNAME"  "\t");        ()

  ;       (.  "ABC_PRGNAME.SET")
  (ABC_PRGNAME_SETUP)
  ;  
  (setq abc_prgname_value "")
  
  ;     (DCL-)
  (if (findfile "ABC_PRGNAME.DCL")
    (setq dcl-id (load_dialog "ABC_PRGNAME"));dcl-id -   DCL
    (progn
      (alert "ABC_PRGNAME.DCL.  Dialog file not found.
             \n\nCancel program.")
      (EXIT)
    )
  )
  ;      :
  ;        . (    Xref)
  (if (not (setq glob_laylist (ABC_LAYER_LIST (+ 1 2 16 32))))
    (progn
      (alert (strcat (ABC_MES 17);17="Thaw one of layer before start program."
                     "\n" (ABC_MES 18)));18="Cancel program."
      (EXIT);  
    )
  )
  ;        . (   )
  (if (not (setq glob_stylelist (ABC_TSTYLE_LIST )))
    (progn
      (alert (strcat (ABC_MES 19);19="No styles with nonzero height."
                     "\n" (ABC_MES 18)));18="Cancel program."
      (EXIT);  
    )
  )

  ;     ,   ,   
  ;("OSMODE"   )
  (ABC_RESTORE_SVAR '(("BLIPMODE" 0)
                      ("DIMZIN" 8);  
                  ; ..
                 ))
  ;  
  (setvar "DIMZIN" 8);       
  
  (setq c-dcl '(-1 -1)) ;    (  )

  ;     (  ""), :
  ; ,      ,    
  (if (not (tblsearch "STYLE" abc_prgname_style))
    (setq abc_prgname_style (strcase (getvar "TEXTSTYLE")))
  )
  ;  ,      ,   
  (if (not (tblsearch "LAYER" abc_prgname_layer))
    (setq abc_prgname_layer (strcase (getvar "CLAYER")))
  )
  (if (not (tblsearch "LAYER" abc_prgname_boxlayer))
    (setq abc_prgname_boxlayer (strcase (getvar "CLAYER")))
  )
  ;     0-256   
  (if (or (< abc_prgname_color 0) (> abc_prgname_color 256))
    (setq abc_prgname_color 256)
  )
  ;    0    2.5
  (if (<= abc_prgname_ht 0)
    (setq abc_prgname_ht 2.5)
  )
  ;    -    
  (setq glob_locklay_str "")
  (setq glob_locklay_str (ABC_UNLOCK_LAYER abc_prgname_boxlayer glob_locklay_str))
  (setq glob_locklay_str (ABC_UNLOCK_LAYER abc_prgname_layer glob_locklay_str))
  ;   
  (if (= glob_mode "CREATE TEXT")
    (progn
      (setvar "TEXTSTYLE" abc_prgname_style)
      (setvar "CECOLOR" (ABC_DIG2STR_COLOR abc_prgname_color));     
      (setq glob_locklay_str (ABC_UNLOCK_LAYER abc_prgname_layer glob_locklay_str))
    )
  )
  ;   (      )
  (setq glob_appname "ABC_PRGNAME")
  (setq glob_reg_appname (ABC_REGISTER_APP glob_appname))
  ;  ,     .   (,  )
  (princ (strcat "\n(C)ABC. C:ABC_PRGNAME. " (ABC_MES 0);0="Drawing text and/or boxes around text"
                  ))
  
  ;    
  (princ (strcat "\n" (ABC_MES 1) ": ";1="Current parameters"
                      (if (= abc_prgname_mode 1)
                        (strcat (ABC_MES 3) " = " (ABC_MES 20) ", ");3="Type" 20="Slotes"
                        (strcat (ABC_MES 3) " = " (ABC_MES 21) ", ";3="Type" 21="Rectangle"
                                (ABC_MES 4) " = " (rtos abc_prgname_rad 2 3) ", ");4="Radius"
                      )
                      (ABC_MES 2) " = " abc_prgname_boxlayer ;2="Layer"
                 ))
  
  (setq loop T)
  (while loop
    ;    (          GET...  ENTSEL)
    (setvar "OSMODE" glob_osm-old)
    (if (= glob_mode "CREATE TEXT")
      (progn
        ;   
        (setq message2user (strcat "\n[" glob_mode "] " (ABC_MES 22);22="Specify insertion point of text or"
                                   " [SS/MoveLast/Settings/EraseBoxes/Help]" ": "))
        ;       get...
        (initget "Settings SS MoveLast EraseBoxes Help")
        ;   (  GET )   
        (setq c (getpoint message2user))
      )
      (progn
        ;   
        (setq message2user (strcat "\n" (ABC_MES 23);23="Select text or"
                                   " [Create/SS/MoveLast/Settings/EraseBoxes/Help]" ": "))
        ;       get...
        (initget "Settings Create SS MoveLast EraseBoxes Help")
        ;   (  GET )   
        (setq c (entsel message2user))
      )
    )
    ;  
    (setq glob_osm-old (getvar "OSMODE"))
    ;    
    (setvar "OSMODE" 0)
    ;       
    (if (= glob_mode "CREATE TEXT")
      (progn
        (setvar "TEXTSTYLE" abc_prgname_style)
        (setvar "CECOLOR" (ABC_DIG2STR_COLOR abc_prgname_color));     
        (setq glob_locklay_str (ABC_UNLOCK_LAYER abc_prgname_layer glob_locklay_str))
      )
    )
    
    ;  
    (cond ;   
          ((= c "Settings");   S(s)   Settings
            (progn
              (setq e (DCL_SETTINGS))
              (if (not e)
                (EXIT)
              )
            ))
          ;     
          ((= c "SS");   SS
            (progn
              (DO_SELECTION_SET)
            ))
          ;       
          ((= c "Create");   C(c)   Create
            (progn
              ;       
              (setq glob_mode "CREATE TEXT")
            ))
          ;    
          ((= c "EraseBoxes");   E(e)   EraseBox
            (progn
              ;       
              (ERASE_BOXES)
            ))
          ;          
          ((= c "MoveLast");   M(m)   MoveLast
            (progn
              (MOVE_LAST)
            ))
          ;    
          ((= c "Help");   H(h)   Help
            (progn
              (ABC_HELP "ABC_PRGNAME");      help 
            ))
;;;          ((= c "Undo");   U(u)   Undo
;;;            (progn
;;;              ;(  )
;;;            ))
          ((= (type c) 'LIST);       getpoint (.. )
            (progn
              (if (= (length c) 2)
                (progn
                  (setq en (car c)); <Entity name> (  )
                  (setq glob_en en)
                  ;   
                  (redraw glob_en 3)
                  ;     ,     ,  ,     
                  (if (ABC_CHECK_OBTYPE en '("TEXT"))
                    (progn
                      ;    
                      (DRAW_BOX en)
                    )
                  )
                  ;  
                  (redraw glob_en 4)
                )
                (progn
                  (setq e 3)
                  (while (or (= e 3) (= e 4))
                    (setq e (DCL_SETTINGS))
                    (if (or (= e 3) (= e 4))
                      (progn
                        (if (= e 4)
                          (setq add "T")
                          (setq add nil)
                        )
                        (setq abc_prgname_value (GET_TEXT_VALUE abc_prgname_value add))
                      )
                    )
                  )
                  (if (not e);  Cancel
                    (EXIT)
                  )
                  (if (= e 1);  OK
                    (progn
                      (CREATE_TEXT c)
                    )
                  )
                  ;     -   .
                )
              )
            ))
          (T ;    (   , ,      Enter)
            (progn
              (setq loop nil);    
            ))
    );cond
  );while loop
  ;          
  (RESTORE_ON_EXIT)
  ;     ( )
  (princ "\n *End ABC_PRGNAME*")
  (prin1); 
) ;end ******* ABC_PRGNAME ***************

; *********************************************************
;
;    Acad ABC_PRGNAME      ABC_PRGNAME
;
; *********************************************************

(defun C:ABC_PRGNAME ()
  (princ "\nLoading ABC_PRGNAME....")
  ;    
  (if (or (findfile "ABC_PRGNAME.FAS") (findfile "ABC_PRGNAME.LSP"))
    (progn
      ;  
      (load "ABC_PRGNAME")
      (princ "OK")
      ;     
      (ABC_PRGNAME)
      ;   ,  ABC_PRGNAME   !!!!
      ;        ,   ,   .
      (setq ABC_PRGNAME nil)
    )
    (alert " Program ABC_PRGNAME not found. ")
  )
  (prin1)
) ;end of **************C:ABC_PRGNAME***************